#include "Vec.h"

double  EPS = 1e-15;

void
test_VecC()
{
   cout << "<< ٥ȥΥƥ >>" << endl;

   VecC x(sqrt(2), sqrt(3), sqrt(5));
   VecC y(8, -5, -2);

   cout << "٥ȥ: x = " << x << endl;
   cout << "٥ȥ: y = " << y << endl;

   cout << ": x + y = " << x + y << endl;
   cout << ": x - y = " << x - y << endl;
   cout << "ñΥޥʥ: -x = " << -x << endl;
   cout << "顼: sqrt(5) * x = " << sqrt(5) * x << endl;
   cout << "顼: x * sqrt(3) = " << x * sqrt(3) << endl;
   cout << "顼: x / sqrt(2) = " << x / sqrt(2) << endl;
   cout << ": x % y = " << x % y << endl;
   cout << ": (x , y) = " << (x , y) << endl;
   cout << "Υ: x.norm() = " << x.norm() << endl;
   cout << "Υ: norm(x) = " << norm(x) << endl;
   cout << ": abs(y) = " << abs(y) << endl;
   cout << ": normalize(x) = " << normalize(x) << endl;

   VecC a, b, c, d, z;
   cout << "٥ȥ z > ";
   cin >> z;

   cout << "a = " << a << endl;
   cout << "b = " << b << endl;
   cout << "c = " << c << endl;
   cout << "d = " << d << endl;
   cout << "z = " << z << endl;

   a = b = c = d = z;
   cout << "a = " << a << endl;
   cout << "b = " << b << endl;
   cout << "c = " << c << endl;
   cout << "d = " << d << endl;
   cout << "z = " << z << endl;

   cout << "a == b = " << (a == b) << endl;
   cout << "a == x = " << (a == x) << endl;
   cout << "a != b = " << (a != b) << endl;
   cout << "a != x = " << (a != x) << endl;

   a += x;
   cout << "a += x = " << a << endl;
   b -= x;
   cout << "b -= x = " << b << endl;
   c *= 2;
   cout << "c *= 2 = " << c << endl;
   d /= 2;
   cout << "d /= 2 = " << d << endl;
}

void
test_VecR()
{
   cout << "<< ԥ٥ȥΥƥ >>" << endl;

   VecR x(sqrt(2), sqrt(3), sqrt(5));
   VecR y(8, -5, -2);

   cout << "٥ȥ: x = " << x << endl;
   cout << "٥ȥ: y = " << y << endl;

   cout << ": x + y = " << x + y << endl;
   cout << ": x - y = " << x - y << endl;
   cout << "ñΥޥʥ: -x = " << -x << endl;
   cout << "顼: sqrt(5) * x = " << sqrt(5) * x << endl;
   cout << "顼: x * sqrt(3) = " << x * sqrt(3) << endl;
   cout << "顼: x / sqrt(2) = " << x / sqrt(2) << endl;
   cout << ": x % y = " << x % y << endl;
   cout << ": (x , y) = " << (x , y) << endl;
   cout << "Υ: x.norm() = " << x.norm() << endl;
   cout << "Υ: norm(x) = " << norm(x) << endl;
   cout << ": abs(y) = " << abs(y) << endl;
   cout << ": normalize(x) = " << normalize(x) << endl;

   VecR a, b, c, d, z;
   cout << "٥ȥ z > ";
   cin >> z;

   cout << "a = " << a << endl;
   cout << "b = " << b << endl;
   cout << "c = " << c << endl;
   cout << "d = " << d << endl;
   cout << "z = " << z << endl;

   a = b = c = d = z;
   cout << "a = " << a << endl;
   cout << "b = " << b << endl;
   cout << "c = " << c << endl;
   cout << "d = " << d << endl;
   cout << "z = " << z << endl;

   cout << "a == b = " << (a == b) << endl;
   cout << "a == x = " << (a == x) << endl;
   cout << "a != b = " << (a != b) << endl;
   cout << "a != x = " << (a != x) << endl;

   a += x;
   cout << "a += x = " << a << endl;
   b -= x;
   cout << "b -= x = " << b << endl;
   c *= 2;
   cout << "c *= 2 = " << c << endl;
   d /= 2;
   cout << "d /= 2 = " << d << endl;
}

void
test_VecCR()
{
   cout << "<< ٥ȥȹԥ٥ȥΥƥ >>" << endl;
   VecR x(1.4, -1.7, -2.23);
   VecC y(1.8, 3.2, -4.5);

   cout << "x = " << x << endl;
   cout << "y = " << y << endl;
   cout << "x * y = " << x * y << endl;
//   cout << "y * x = " << y * x << endl;
}

void
test_misc()
{
   VecR x(1.4, -1.7, -2.23);
   VecC y(1.8, 3.2, -4.5);

   cout << "x.size() = " << x.size() << endl;
   cout << "x = " << x << endl;
   x.realloc(8);
   cout << "x.realloc(8) = " << x << endl;
   cout << "x.size() = " << x.size() << endl;
   y.clear(-1.4);
   cout << "y.clear(-1.4) = " << y << endl;
}

void
test_speed()
{
   VecR x1(1.4, -1.7, -2.23), y1(3.1, 8.3, -6.6), z1;
   VecC x2(-2.9, 5.4, -9.8), y2(1.8, 3.2, -4.5), z2;

   z1 = x1 + y1;
   z1 = x1 - y1;
   z1 = x1 % y1;
   z2 = x2 + y2;
   z2 = x2 - y2;
   z2 = x2 % y2;
}

int
main(int argc, char *argv[])
{
   test_VecC();
   test_VecR();
   test_VecCR();
   test_misc();

   for (int i = 0; i < 100000; i++)
      test_speed();
}
